// Name	::	Auto Save Load file
// ================
// Made by	::	McTwist
// Date	::	09-06-29
// Info	::	Load save on start of server, and saves it on closing
// License	::	Free to use
// ================

// No need to load it when the person can do that
if (!$Server::dedicated)
{
	echo("AutoSaveLoad: No need on non-dedicated servers");
	return;
}

// Load the Dedicated Loader
// Easter Egg!
// Working on an own DediLoad due the fact that I've not 
// found any function that works on dedicated internetservers
//exec("./dediload.cs");

// Load Randys Dedicated Saver
exec("./dedisave.cs");

// Reloading addon
if (isPackage(Script_AutoSaveLoad))
	deactivatePackage(Script_AutoSaveLoad);

$Pref::AutoLoaded = false;

// Saves to the temporarily folder
function TempSaveMap()
{
	echo("AutoSaveLoad: Saving bricks");
	TempDediSave(); // Calling Randys Dedicated Saver Modified function
}
// Load from the temporarily folder
function TempLoadMap(%client, %type)
{
	%tempFile = "base/server/temp/temp.bls";
	if (!isFile(%tempFile))
		return;
	// Wait for everything to load
	ServerCmdReloadBricks(%client);
}

// Writes information from a file to an another file
function WriteFromToFile(%from, %to)
{
	%fromStream = new fileObject();
	%toStream = new fileObject();
	%fromStream.openForRead(%from);
	%toStream.openForWrite(%to);
	
	while (!%fromStream.isEOF())
		%toStream.writeLine(%fromStream.readLine());
	
	%toStream.close();
	%fromStream.close();
	%toStream.delete();
	%fromStream.delete();
}

package Script_AutoSaveLoad
{
	// Load when host joins. Calls only once and to anyone that joins the server
	function GameConnection::onClientEnterGame(%client)
	{
		Parent::onClientEnterGame(%client);
		// Note host
		if (getNumKeyID() $= $client.bl_id)
			messageClient(%client, '', "\c6Please use Quit(); on server console to safely save and close the server.");
		
		if ($Pref::AutoLoaded)
			return;
		$Pref::AutoLoaded = true;
		schedule(10, 0, "TempLoadMap", %client);
		messageClient(%client, '', "You triggered Auto-Load-Last-Save.");
	}
	
	// Calls when using quit();
	function onExit()
	{
		TempSaveMap();
		Parent::onExit();
	}
};
activatePackage(Script_AutoSaveLoad);